;
;	subttl MACRO LIBRARY 04/01/88
;	page
;
; LAST 09/08/91 NEXT LAST 12/29/88 FIRST 01/30/87
; 11/03/92 added DISPLAY
; 01/08/93 added AT
DMZ	MACRO	X0
	IFNB	<X0>
	DB	X0,0
	ENDIF
	ENDM
AT	MACRO	X0
	DB	X0
	ENDM
AZ	MACRO	X0
	DB	X0,0
	ENDM
D8	MACRO	X0
	DB	X0
	ENDM
MDMZ	MACRO	X0,X1,X2,X3,X4,X5,X6,X7
	DMZ	X0
	DMZ	X1
	DMZ	X2
	DMZ	X3
	DMZ	X4
	DMZ	X5
	DMZ	X6
	DMZ	X7
	ENDM
;NOP	MACRO
;	DB 0
;	ENDM
;	Line Feed and Carriage Return
CR	MACRO
	DB	13,10
	ENDM
C0	MACRO
	CR
	DB	0
	ENDM	
INIT	MACRO	START,COUNT,VALUE
	LOCAL	LABEL
	PUSH	SI
	PUSH	CX
	PUSH	AX
	MOV	SI,OFFSET START
	MOV	CX,COUNT
	MOV	AL,VALUE
LABEL:
	MOV	[SI],AL
	INC	SI
	LOOP	LABEL
	POP	AX
	POP	CX
	POP	SI
	ENDM
LOC	MACRO	L1,L2,D1,LA1,LA2,D2
	DB	L1,L2,D1,LA1,LA2,D2
	ENDM
LOCN	MACRO	NAME,L1,L2,D1,LA1,LA2,D2
	AZ	NAME
	DB	L1,L2,D1,LA1,LA2,D2
	ENDM
TAB_COL	MACRO	COLUMN
	PSHS	CX,DX
	MOV	DL,COLUMN
	CALL	PUT_TAB_COLUMN
	PULS	DX,CX
	ENDM
PSHS	MACRO	R0,R1,R2,R3,R4,R5,R6,R7
	IFNB	<R0>
	PUSH	R0
	ENDIF
	IFNB	<R1>
	PUSH	R1
	ENDIF
	IFNB	<R2>
	PUSH	R2
	ENDIF
	IFNB	<R3>
	PUSH	R3
	ENDIF
	IFNB	<R4>
	PUSH	R4
	ENDIF
	IFNB	<R5>
	PUSH	R5
	ENDIF
	IFNB	<R6>
	PUSH	R6
	ENDIF
	IFNB	<R7>
	PUSH	R4
	ENDIF
	ENDM
PULS	MACRO	R0,R1,R2,R3,R4,R5,R6,R7
	IFNB	<R0>
	POP	R0
	ENDIF
	IFNB	<R1>
	POP	R1
	ENDIF
	IFNB	<R2>
	POP	R2
	ENDIF
	IFNB	<R3>
	POP	R3
	ENDIF
	IFNB	<R4>
	POP	R4
	ENDIF
	IFNB	<R5>
	POP	R5
	ENDIF
	IFNB	<R6>
	POP	R6
	ENDIF
	IFNB	<R7>
	POP	R7
	ENDIF
	ENDM
MESSAGE	MACRO	YES,NO
	LOCAL	DOYES,DONO,DOEXIT
	IFNB	<NO>
	JC	DONO
	ENDIF
	IFNB	<YES>
	JC	DOEXIT
	CALL	YES
	JMP	DOEXIT
	ENDIF
	IFNB	<NO>
DONO:
	CALL	NO
	ENDIF
DOEXIT:
	ENDM
INCWORD	MACRO	WORD
	PUSH	AX
	MOV	AX,[WORD]
	INC	AX
	MOV	[WORD],AX
	POP	AX
	ENDM
SHOWIT	MACRO	ARG
	MOV	SI,OFFSET ARG
	CALL	PRINT
	ENDM
DUMP	MACRO	WORD
	PUSHF
	PUSH	AX
	PUSH	BX
	MOV	BX,WORD
	CALL	PUTSPACE
	CALL	BINIHEX
	POP	BX
	POP	AX
	POPF
	ENDM
DISPLAY	MACRO	MESSAGE
	MOV	BX,OFFSET MESSAGE
	CALL	PRINT
	ENDM
